/////////////////////////////// Reposa antebrazos///////////////////////////////


////////////////// Creado por Luis Rodríguez para la Fundación ONCE - 2021 /////////////////



//Este software se distribuye bajo licencia Creative Commons - Attribution - NonCommercial - ShareAlike license.
//https://creativecommons.org/licenses/by-nc-sa/4.0/
//Este software no tiene ningún tipo de garantía y el usuario será el único responsable de su uso



//////////Este prolongador está pensado para dar un soporte adicional con mayor o menor altura que la mesa para aquellas personas que por uno u otro motivo lo puedan necesitar//////////


///////////////Todos los parámetros están medidos en milímetros///////////////


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////Parámetros definibles por el usuario////////////////////

/*[Parámetros de la mesa donde se va a colocar]*/

//Borde de la mesa 
Borde = "Plano";      //[Plano,Redondeado]

//Grosor de la mesa 
GrueMesa = 28;           //[10:0.1:50]


/*[Parámetros del prolongador de mesa]*/

//Profundidad total del reposa antebrazos
ProfTotal = 345;          //[190:5:300]

//Parte voladiza del reposa antebrazos (donde realmente se hace el apoyo)
ProfVol = 260;           //[100:5:210]

//Anchura del reposa antebrazos
AnchoTotal = 270;        //[150:1:250]

//Grosor sobre la mesa
GrueSoMesa = 5;           //[4:0.5:10]


//Grosor mínimo de la parte inferior  
GrueInf = 8;          //[5:0.5:12]

//
Posicion = "Bajar";      //[Elevar,Bajar]

//Diferencia entre el borde superior de la mesa y la parte superior del prolongador (Valor entre 0 y 100)
Diferencia = 90;         //[0:2:100]

///////////////////////////////////Parámetros fijos///////////////////////////////////

/* [Hidden] */

Redondeo = 4;

Suavizado = 20;

///////////////////////////////////Módulos///////////////////////////////////



module BaseBajar() {
    translate([ProfVol-Redondeo*2,0,0])
        cube([ProfTotal-ProfVol-Redondeo,GrueSoMesa+GrueMesa+GrueInf-Redondeo*2,AnchoTotal-Redondeo*2]);
    translate([ProfVol-Redondeo*2,0,0])
                cube([30,Diferencia,AnchoTotal-Redondeo*2]);
    hull() {
        translate([ProfVol-Redondeo*2+30-Redondeo,Diferencia+30,0])
            cylinder(AnchoTotal-Redondeo*2, r=Redondeo,$fn=100);
        translate([ProfVol-Redondeo*3+30,Diferencia,0])
            cube([Redondeo,Redondeo,AnchoTotal-Redondeo*2]);
        translate([0,Diferencia+Redondeo,0])
            cylinder(AnchoTotal-Redondeo*2, r=Redondeo,$fn=100);
   }
}

module BaseElevar() {
    translate([ProfVol-Redondeo*2,0,0])
        cube([ProfTotal-ProfVol-Redondeo,GrueSoMesa+GrueMesa+GrueInf-Redondeo*2,AnchoTotal-Redondeo*2]);
    translate([ProfVol-Redondeo*2,-Diferencia,0])
                cube([30,Diferencia,AnchoTotal-Redondeo*2]);
    hull() {
        translate([ProfVol-Redondeo*2+30-Redondeo,-Diferencia+30,0])
            cylinder(AnchoTotal-Redondeo*2, r=Redondeo,$fn=100);
        translate([ProfVol-Redondeo*3+30,-Diferencia,0])
            cube([Redondeo,Redondeo,AnchoTotal-Redondeo*2]);
        translate([0,-Diferencia+Redondeo,0])
            cylinder(AnchoTotal-Redondeo*2, r=Redondeo,$fn=100);
   }
}

module Principal() {
if(Posicion=="Bajar")
minkowski(){
BaseBajar();
sphere(r=Redondeo,$fn=Suavizado);
}
if(Posicion=="Elevar")
minkowski(){
BaseElevar();
sphere(r=Redondeo,$fn=Suavizado);
}
}

if(Borde=="Redondeado")
difference(){
Principal(); 
translate([ProfVol+GrueMesa/2,GrueSoMesa-Redondeo,-Redondeo]) 
            cube([ProfTotal,GrueMesa,AnchoTotal+Redondeo*2]);
translate([ProfVol+GrueMesa/2,GrueMesa/2+GrueSoMesa-Redondeo,-Redondeo])
            cylinder(AnchoTotal+Redondeo*2,d=GrueMesa,$fn=100);
}

if(Borde=="Plano")
difference(){
Principal(); 
translate([ProfVol+Redondeo,GrueSoMesa-Redondeo,-Redondeo]) 
            cube([ProfTotal,GrueMesa,AnchoTotal+Redondeo*2-1]);
}




